// iPhone Compass  by kako.com

#include <stdio.h>
#include "uart.h"
#include "i2c_master.h"

// i2c address
#define		I2C_ADR		0x42

volatile int timer_val;
void wait_usec(int tmax)
{
	int t;
	tmax= tmax/3;  // K
	for (t=0;t<tmax;t++) { timer_val=t; }
}
void wait_msec(int m)
{
	int t;
	for (t=0;t<m;t++) { wait_usec(1000); }

}

int main()
{
	int r;
	char buf[80];
	unsigned char d1,d2;
	int x;

	i2c_master_init();
	wait_msec(500); // HMC6532 power on wait
	
	rs_init(9600);    // UARTݒ  9600bps
	rs_puts("\n");
	rs_puts("test I2C for HMC6352\n");
	rs_puts("\n");
	
	while (1) {
		
		r=i2c_start(I2C_ADR,I2C_WRITE_MODE);
		if (r!=0) { rs_puts("Error: no ACK <1>\n"); }
		i2c_write( 'A' );
		i2c_stop();
		
		wait_usec(1100);
		
		r=i2c_start(I2C_ADR,I2C_READ_MODE);
		if (r!=0) { rs_puts("Error: no ACK <1'>\n"); }
		d1 = i2c_read(I2C_READ_WITH_ACK);
		d2 = i2c_read(I2C_READ_WITH_NACK);
		i2c_stop();
		
		x = ( (int)d1<<8 ) + (d2);
		x = x /10;
		
		sprintf(buf,"%d\n",x); rs_puts(buf); // UARTɏo
		
		wait_msec(100);
	}
	
	return 0;
}
